import 'package:dgtdriver/models/Piece.dart';

abstract class DGTProtocol {
  static bool reverseBoardOrientation = false;
  static List<String> get squares => reverseBoardOrientation ? _SQUARES.reversed.toList() : _SQUARES;

  static const List<String> _SQUARES = [
    'h1',
    'g1',
    'f1',
    'e1',
    'd1',
    'c1',
    'b1',
    'a1',
    'h2',
    'g2',
    'f2',
    'e2',
    'd2',
    'c2',
    'b2',
    'a2',
    'h3',
    'g3',
    'f3',
    'e3',
    'd3',
    'c3',
    'b3',
    'a3',
    'h4',
    'g4',
    'f4',
    'e4',
    'd4',
    'c4',
    'b4',
    'a4',
    'h5',
    'g5',
    'f5',
    'e5',
    'd5',
    'c5',
    'b5',
    'a5',
    'h6',
    'g6',
    'f6',
    'e6',
    'd6',
    'c6',
    'b6',
    'a6',
    'h7',
    'g7',
    'f7',
    'e7',
    'd7',
    'c7',
    'b7',
    'a7',
    'h8',
    'g8',
    'f8',
    'e8',
    'd8',
    'c8',
    'b8',
    'a8',
  ];

  static const Map<int, Piece> PIECES = {
    0x0: null,
    0x1: Piece(notation: 'P', role: 'pawn', color: 'white'),
    0x2: Piece(notation: 'R', role: 'rook', color: 'white'),
    0x3: Piece(notation: 'N', role: 'knight', color: 'white'),
    0x4: Piece(notation: 'B', role: 'bishop', color: 'white'),
    0x5: Piece(notation: 'K', role: 'king', color: 'white'),
    0x6: Piece(notation: 'Q', role: 'queen', color: 'white'),
    0x7: Piece(notation: 'p', role: 'pawn', color: 'black'),
    0x8: Piece(notation: 'r', role: 'rook', color: 'black'),
    0x9: Piece(notation: 'n', role: 'knight', color: 'black'),
    0xa: Piece(notation: 'b', role: 'bishop', color: 'black'),
    0xb: Piece(notation: 'k', role: 'king', color: 'black'),
    0xc: Piece(notation: 'q', role: 'queen', color: 'black'),
    0xd: null,
    /* Magic piece: Draw */
    0xe: null,
    /* Magic piece: White win */
    0xf: null /* Magic piece: Black win */
  };
}